/**************************************************************
 *
 *  Uebung 10:  Billettautomat
 *              Billett-Funktionen
 *
 *  File:       billett.h
 *  Autor:      B. Freitag, TSU
 *
 *  History:
 *  V1.00       27. 8.2000  bf    Neu
 *  V2.00       12. 6.2001  bf    Ueberarbeitung fuer PC-Version
 *
 **************************************************************
 */

#ifndef Billett_h
#define Billett_h


/* ============================================================
 * Typendeklarationen
 * ============================================================
 */
typedef struct 	{ 			/* Billett		             */
		int  PLZ;		/*  Postleitzahl                     */
		char Ort[20];		/*  Ortsname			     */
		float Preis;		/*  Fahrpreis, 1/1, 1.KLasse, einfach*/
		}	TBillett;

typedef enum { halb,    ganz 	} 	EHalbtax;
typedef enum { kl2,     kl1 	} 	EKlasse;
typedef enum { einfach, retour 	}	ERetour;

typedef struct  {
		EHalbtax	Halbtax;
		EKlasse		Klasse;
		ERetour		Retour;
		} 	TBillettOptionen;


/* ============================================================
 * Funktionsdeklarationen
 * ============================================================
 */

char	HoleBillettDaten(int p, TBillett *b);
void	BillettDatenAnzeigen(TBillett b, TBillettOptionen o);
float	BillettPreisBerechnen(TBillett b,TBillettOptionen o);
void	BillettDrucken(TBillett b, TBillettOptionen o);

#endif