/**************************************************************
 *
 *  Uebung 10:  Billettautomat
 *              Input- / Output-Funktionen
 *
 *  File:       InOut.c
 *  Autor:      B. Freitag, TSU
 *
 *  History:    
 *  V1.00       27. 8.2000  bf    Neu
 *  V2.00       12. 6.2001  bf    Ueberarbeitung fuer PC-Version
 *
 **************************************************************
 */

#include <stdio.h>
#include <conio.h>
#include "InOut.h"



char   ZielortEinlesen(int *p)
/* ------------------------------------------------------------
 * Liest einen String ein und prueft, ob 4 Ziffern eingegeben
 * worden sind
 *
 * Out: 	eingegebene PLZ
 * Return:      = 1: Abbruch; = 0: PLZ eingegeben
 * ------------------------------------------------------------
 */
{
int plz;
char i;
char str[21];
char fehler;
char cancel = 0;

gotoxy(1,EingabePos);
printf("PLZ eingeben ( Abbrechen mit [c] ) : "); clreol();
do {
   gets(str);

   if (tolower(str[0]) == 'c')
      cancel = 1;
   else
      {
      plz = 0;
      fehler = 0;
      for (i = 0; i< 4; i++)
	 {
	 if (isdigit(str[i]))
	    plz = plz*10 + (str[i]-'0');
	 else
	    fehler = 1;
	 }
      if (fehler)
	 {
	 gotoxy(1,FehlerPos);
	 printf("Bitte eine PLZ eingeben (4 Ziffern!) :"); clreol();
	 }
      }
   }
while(fehler && !cancel);
*p = plz;
return(cancel);
}


char  OptionenEinlesen(TBillettOptionen *o)
/* ------------------------------------------------------------
 * Liest die 3 Optionen
 *	       Klassenwahl ('1','2'),
 *             1/1 ('G') oder 1/2 ('H') und
 *	       einfach ('E') oder retour('R') ein
 * und setzt die Optionen entsprechend
 * wird 'F' eingegeben, so wird dies als Ende der Optionenwahl
 * ausgewertet, mit 'C' kann die Billettwahl auch hier abge-
 * brochen werden. Alle anderen Zeichen werden ignoriert.
 *
 * In/Out :  o : Billetoptionen, werden entsprechend der Eingabe angepasst
 * Return : Ende der Optionenwahl (0= Opt. gewaehlt, 1=fertig, 2=cancel)
 * ------------------------------------------------------------
 */
{
char str[20];
char fertig = 0;

gotoxy(1,HinweisPos);
printf("Optionen: [1].Klasse     / [2].Klasse \n");    clreol();
printf("          [E]infach	 / [R]etour   \n");    clreol();
printf("          [G]anzer Preis / [H]alber Preis \n");clreol();
printf("[f] Optionenwahl beenden; [c] = Billettwahl abbrechen\n"); clreol();

gotoxy(1,EingabePos);
printf("Optionen waehlen: "); clreol();

gets(str);
switch(tolower(str[0]))
	{
	case '1':	o->Klasse = kl1;	break;
	case '2':	o->Klasse = kl2;	break;
	case 'g':	o->Halbtax= ganz;	break;
	case 'h':	o->Halbtax= halb;	break;
	case 'r':	o->Retour = retour;	break;
	case 'e':	o->Retour = einfach;    break;
	case 'f':	fertig = 1;		break;
	case 'c':	fertig = 2;		break;
	}
return(fertig);
}


void    TitelAnzeigen(void)
/* ------------------------------------------------------------
 * Zeigt den Titel an
 * ------------------------------------------------------------
 */
{
  clrscr();
  printf("                   Billettautomat V2.0\n\n");
}



void	UnbekanntePLZ(int PLZ)
/* ------------------------------------------------------------
 * Zeigt eine Fehlermeldung, dass diese PLZ unbekannt ist
 *
 * In: 	        eingegebene PLZ
 * Return:      -
 * ------------------------------------------------------------
 */
{
char str[21];
gotoxy(1,FehlerPos);
printf("Postleitzahl %d unbekannt\n\n",PLZ); clreol();
gotoxy(1,HinweisPos);
printf("Druecken Sie [Enter]");
gets(str);
}

void BillettEntnehmen(void)
/* ------------------------------------------------------------
 * Wartet, bis das Billett entnommen ist
 * ------------------------------------------------------------
 */
{
char str[21];
printf("Druecken Sie [Enter] zur Entnahme des Billetts!\n\n");
gets(str);
}


