/**************************************************************
 *
 *  Uebung 10:  Billettautomat
 *              Billett-Funktionen
 *
 *  File:       billett.c
 *  Autor:      B. Freitag, TSU
 *
 *  History:
 *  V1.00       27. 8.2000  bf    Neu
 *  V2.00       12. 6.2001  bf    Ueberarbeitung fuer PC-Version
 *
 **************************************************************
 */

#include <stdio.h>
#include <conio.h>
#include "Billett.h"
#include "InOut.h"

#define AnzBillett  7


const TBillett	BillettListe[AnzBillett] =
	{ { 8000,	"Zrich",	13.50 },
	  { 8600,	"Dbendorf",	12.70 },
	  { 8610,	"Uster",	10.50 },
	  { 8608,	"Bubikon",	 7.20 },
	  { 8640,	"Rapperswil",	 4.10 },
	  { 3000,	"Bern",		45.00 },
	  { 1000,	"Genf",		83.50 } };



char	HoleBillettDaten(int p, TBillett *b)
/* ------------------------------------------------------------
 * Prft die eingebene PLZ auf Vorhandensein und liefert die
 * Daten dieses Billetts zurueck
 *
 * In : p : PLZ
 * Out: b : Billettdaten
 * Return: 1 = gueltige PLZ, 0 = keine gueltige PLZ
 * ------------------------------------------------------------
 */
{
int i;
char gefunden = 0;

for (i=0; i<AnzBillett; i++)
    if (BillettListe[i].PLZ == p)
	{
	gefunden = 1;
		*b = BillettListe[i];
		}
return (gefunden);
}

void	BillettDatenAnzeigen(TBillett b, TBillettOptionen o)
/* ------------------------------------------------------------
 * Zeigt das gewaehlte Billett mit den gewaehlten Optionen an.
 *
 * In :  b  : Billettdaten
 *	 o  : Optionensadten
 * ------------------------------------------------------------
 */
{
gotoxy(1,BillettPos);
printf("gewhltes Billett: nach %s, %c.Klasse, %s Preis, %s, Fr. %5.2f \n",
		b.Ort,
		o.Klasse==kl1 ? '1' : '2',
		o.Halbtax==ganz ? "1/1" : "1/2",
		o.Retour==retour? "retour " : "einfach",
		BillettPreisBerechnen(b,o) );
}


float	BillettPreisBerechnen(TBillett b, TBillettOptionen o)
/* ------------------------------------------------------------
 * Entnimmt den Fahrpreis aus der Tabelle und berchsichtigt
 * die gewuenschten Optionen.
 *
 * In :  b		: Billettdaten
 *		 o		: Optionensadten
 *
 * Return: Fahrpreis in Fr.
 * ------------------------------------------------------------
 */
{
float preis;

preis = b.Preis;
if (o.Klasse == kl1)
    preis = preis * 1.5;
if (o.Halbtax == halb)
    preis = preis * 0.5;
if (o.Retour)
    preis = preis * 2;
return(preis);

}

void	BillettDrucken(TBillett b, TBillettOptionen o)
/* ------------------------------------------------------------
 * Druckt das Billet anhand der Parameter.
 *
 * In :  b		: Billettdaten
 *		 o		: Optionensadten
 * Return: -
 * ------------------------------------------------------------
 */
{
clrscr();
printf("+------------------------+\n");
printf("| Billett %d.Klasse       |\n", o.Klasse==kl1? 1 : 2);
printf("| nach                   |\n");
printf("| %4d %-16s  |\n",              b.PLZ, b.Ort);
printf("|                        |\n");
printf("| ");
if (o.Halbtax==halb)
  printf("1/2-Preis Abo  ");
else
  printf("1/1-Preis      ");

if (o.Retour==retour)
  printf("<===>");
else
  printf("---->");
printf("   |\n");
printf("|              Fr. %5.2f |\n", BillettPreisBerechnen(b,o));
printf("+------------------------+\n");
printf("\n");
}







